#!/usr/bin/python
#-*- coding: utf-8 -*-

# ---- MEGAFONSMS
# Программа megafonsms предназначена для отправки SMS-сообщений
# абонентам компании "Мегафон-Урал" из командной строки Linux/UNIX.
# Автор программы: Александр Лубягин (г.Киров, Кировская область, Россия)
# Данное программное обеспечение опубликовано под лицензией GNU GPL
# Version 3 License, см. файл LICENSE
# * Для отображения capcha-изображений используется внешняя программа.
# * Сервис отправки сообщений "Мегафон-Урал - Отправка SMS" накладывает
# ограничение на длину сообщения SMS в 280 символов.
# ---- DONATIONS
# Если Вы желаете помочь автору в написании и выпуске новых 
# версий существующих программ, то Вы можете перечислить ему
# определенную денежную сумму на расчетный счет в Сбербанке,
# сделать перевод на кошелек Webmoney, либо - на кошелек Яндекс.Денег.
# Реквизиты расчетных счетов для таких добровольных пожертвований
# опубликованы на странице: http://lubyagin.discrete.ru/donation.html
# ---- ENGLISH
# This software is under GNU GPL Version 3 License, see LICENSE file
# URL: http://www.gnu.org/licenses/gpl-3.0.html
# Author: Alexander Lubyagin (Russia, Kirov)
#  E-mail: lubyagin@yandex.ru
#  Jabber: lubyagin@jabber.ru
#  Site: http://lubyagin.discrete.ru/
# ----

import httplib # HTTPConnection
import urllib # urlencode
from random import choice
import re # findall()
import os # system()
import time # sleep()

# filename to filename+'.pnm'
def preprocess(filename):
  # Process file of GIF format and convert it
  try:
    print 'preprocess...'
    os.system('gif2png %s' % (filename))
    os.remove(filename)
    os.system('pngtopnm %s >> %s.pnm' % (filename[:-3]+'png',filename))
    os.remove(filename[:-3]+'png')
  except:
    return False
  # Remove file of GIF format
  try:
    os.remove(filename)
  except:
    return False
  # Remove file of PNG format
  try:
    os.remove(filename[:-3]+'png')
  except:
    return False
  return True

# Configuration python file
from config import *

def cut_img_src_smsgif(html):
  t = re.findall("(?:img|IMG)\s*?(?:src|SRC)=\"/images/sms/sms\.gif\?s=(\d+)\"",html)
  if len(t) > 0: return t[0]
  else: return None

# html in windows-1251, result in UTF-8
def get_sending_code(html):
  t = re.findall(unicode(">Сообщение отправлено\. Номер сообщения: (\S*?)<",'UTF-8').encode('CP1251'),html)
  if len(t) > 0: return unicode(t[0],'CP1251').encode('UTF-8')
  else: return None

# html in windows-1251, result in UTF-8
def get_deliver_message(html):
  t = re.findall(unicode(">(Статус сообщения.*?)<",'UTF-8').encode('CP1251'),html)
  if len(t) > 0: return unicode(t[0],'CP1251').encode('UTF-8')
  else: return None

# html in windows-1251, result in UTF-8
def get_delivered(html):
  t = re.findall(unicode(">(Статус сообщения.*?доставлено.*?)<",'UTF-8').encode('CP1251'),html)
  if len(t) > 0: return True
  else: return False

hostname = 'www.megafonural.ru'

agents = [
  'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.6) Gecko/2009011913 Firefox/3.0.6',
  'Opera/9.63 (Windows NT 5.1; U; ru) Presto/2.1.1',
  'Opera/9.62 (Windows NT 5.1; U; ru) Presto/2.1.1',
  'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.4) Gecko/2008102920 Firefox/3.0.4',
  'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.5) Gecko/2008120122 Firefox/3.0.5',
]

agent = choice(agents)
print agent

def go_get(hostname,anchor,cookies,agent):
  conn = httplib.HTTPConnection(hostname)
  conn.connect()
  conn.putrequest("GET", anchor)
  conn.putheader("Cookie",cookies)
  conn.putheader("User-Agent",agent)
  conn.endheaders()
  response = conn.getresponse()
  data = response.read()
  conn.close()
  return (response.status, response.reason, data)

def go_post(hostname,anchor,params,agent):
  conn = httplib.HTTPConnection(hostname)
  conn.connect()
  conn.putrequest("POST", anchor)
  conn.putheader("Content-Type", "application/x-www-form-urlencoded")
  conn.putheader("Accept", "text/plain")
  conn.putheader("Content-Length", str(len(params)))
  conn.putheader("User-Agent", agent)
  conn.endheaders()
  conn.send(params)
  response = conn.getresponse()
  cookies = response.msg.getheader("Set-Cookie")
  location = response.msg.getheader("Location")
  data = response.read()
  conn.close()
  return (response.status, response.reason, cookies,location, data)

def get_phones():
  import os
  phones = {}
  HOME=os.environ['HOME']
  RC_MEGAFONSMS='%s/.megafonsms'%(HOME)
  def get_i(a,i,default=None):
    if i <= len(a)-1:
      return a[i]
    else:
      return default
  f = open(RC_MEGAFONSMS)
  lines = f.readlines()
  for line in lines:
    a = line.split(' ')
#    print a,a[0],len(a)
    alias = get_i(a,0,'').strip()
    phone = get_i(a,1,'').strip()
    if alias <> '':
      phones.update({alias:phone})
  f.close()
  return phones

def get_checkcode_filename():
  filename = ''
  id = ''
  try:
    result = go_get(hostname,'/sms/','',agent)
    id = cut_img_src_smsgif(result[-1])

    result = go_get(hostname,'/images/sms/sms.gif?s='+id,'',agent)
    data = result[-1]
    filename = id+'.gif'
    f = open(filename,'w')
    f.write(data)
    f.close()

    # Process file of GIF format and convert it to PNM format
    preprocess(filename)
    if XWINDOW:
      if TERMINAL:
        # X Window System Virtual terminal-based view
        os.system('%s %s &' % (VIEWTERMINAL,filename+'.pnm'))
      else:
        # X Window System-based view
        os.system('%s %s > /dev/null &' % (VIEWXWINDOW,filename+'.pnm'))
    else:
      # Simple console in text mode
      os.system('%s %s' % (VIEWTERMINAL,filename+'.pnm'))
  finally:
    return [id,filename]

def manual_sending(phones):
  print 'Code:',
  s = raw_input()

  prefix = '922'
  print 'Phone: +7 %s' % prefix,
  phone = raw_input()
  if phone in phones.keys():
    phone = phones[phone] # phone by alias
  print phone

  print 'Message:',
  message = unicode(raw_input(),'UTF-8').encode('CP1251')

  params_post_sms = urllib.urlencode({
  'cc': id, 'prefix': prefix,
  'Addr': phone,
  'txtSM': message, 'messlen': len(message),
  'send_time': 'now',
  'vixod': s, # 10 characters
  #'send_time': 'later',
  #'later_day': '31',
  #'later_month': '1',
  #'later_year': '2009',
  #'later_hour': '0',
  #'later_min': '59',
  })

  result = go_post(hostname,'/sms/?s',params_post_sms,agent)
  html = result[-1]
  code = get_sending_code(html)
  print 'Сообщение отправлено. Код сообщения: %s' % code

  timeout = 5
  print 'Timeout %d seconds ...' % timeout

  while True:
    time.sleep(timeout)
    result = go_get(hostname,'/sms/?info='+code,'',agent)
    html = result[-1]
    status = get_deliver_message(html)
    print status
    if get_delivered(html): break

# main procedure
phones = {}
try:
  phones = get_phones()
except:
  phones = {}
print phones
try:
  print 'Press [Enter] and read check code (captcha), then press \'q\' to type'\
    +' this code:',
  s = raw_input()
  [id,filename] = get_checkcode_filename()
  print id
  manual_sending(phones)
  os.remove(filename)
except:
  pass
# Remove file of GIF format
try:
  os.remove(filename)
except:
  pass
# Remove file of PNM format
try:
  os.remove(filename+'.pnm')
except:
  pass

# END
